/*================================================================================================================*/
// ********************************* THESE ARE THE INFORMATIONS OF THE MAP: ************************************* //
/*================================================================================================================*/
// ANALYZED BY DANY:
// GREAT PLAINS BY ENSEMBLE:
// JUNE 2003:
/*==================================================================================================================*/
// ******************************** MAIN ENTRY POINT FOR RANDOM MAP SCRIPT: ************************************* //
/*================================================================================================================*/
include "mercenaries.xs";
void main(void)
{
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.01);
/*================================================================================================================*/
// ********************************* CHOOSES WHICH NATIVES APPEAR ON THE MAP: *********************************** //
/*================================================================================================================*/
// NONE FOR NOW:
/*----------------------------------------------------------------------------------------------------------------*/
      int subCiv0=-1;
      int subCiv1=-1;
      int subCiv2=-1;
      int subCiv3=-1;
/*----------------------------------------------------------------------------------------------------------------*/
       if (rmAllocateSubCivs(4) == true)
/*----------------------------------------------------------------------------------------------------------------*/	   
   {
/*----------------------------------------------------------------------------------------------------------------*/   
		subCiv0=rmGetCivID("Comanche");
      if (subCiv0 >= 0)
         rmSetSubCiv(0, "Comanche");

      subCiv1=rmGetCivID("Comanche");
      if (subCiv1 >= 0)
         rmSetSubCiv(1, "Comanche");

      subCiv2=rmGetCivID("Comanche");
      if (subCiv2 >= 0)
         rmSetSubCiv(2, "Comanche");

		subCiv3=rmGetCivID("Comanche");
      if (subCiv3 >= 0)
         rmSetSubCiv(3, "Comanche");
/*----------------------------------------------------------------------------------------------------------------*/		 
   }		 
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.05);
/*================================================================================================================*/
// ****************************************** PICKS THE MAP SIZE: *********************************************** //
/*================================================================================================================*/   
// NONE FOR NOW:
/*----------------------------------------------------------------------------------------------------------------*/
	  // int playerTiles=10500;
	     int playerTiles=21000;
   
      if (cNumberNonGaiaPlayers >4)
		  // playerTiles = 9500;
             playerTiles = 19000; 
	  
	  if (cNumberNonGaiaPlayers >6)
          // playerTiles = 8000;
             playerTiles = 16000;
	  
	  int size=2.0*sqrt(cNumberNonGaiaPlayers*playerTiles);
	  rmEchoInfo("Map size="+size+"m x "+size+"m");
	  rmSetMapSize(size, size);
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.10);
/*================================================================================================================*/
// ***************************************** PICKS THE MAP PARAMETERS: ****************************************** //
/*================================================================================================================*/
// NONE FOR NOW:
/*----------------------------------------------------------------------------------------------------------------*/
	  // PICKS A DEFAULT WATER HEIGHT:
	  rmSetSeaLevel(0.0);

      // SET THE MAP ELEVATION PARAMETERS:
	  rmSetMapElevationParameters(cElevTurbulence, 0.02, 7, 0.5, 8.0);
	  
	  // PICKS DEFAULT TERRAIN:
      rmSetBaseTerrainMix("texas_dirt");
	  
	  // PICKS THE TERRAIN INITIALIZATION:
	  rmTerrainInitialize("texas\groundforestdirt_tex", 5.0);
	  
	  // SET THE LIGHTING:
	  rmSetLightingSet("Texas");
	  
	  // SET THE MAP TYPE:
	  rmSetMapType("texas");
	  rmSetMapType("land");
	  rmSetMapType("grass");

	  // SET WORLD CIRCLE CONSTRAINT:
	  rmSetWorldCircleConstraint(true);
	  
	  // CHOOSE THE MERCS:
	  chooseMercs();
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.15);
/*================================================================================================================*/
// ************************ DEFINE SOME CLASSES: THESE ARE USED LATER FOR CONSTRAINTS: ************************** //
/*================================================================================================================*/
// NONE FOR NOW:
/*----------------------------------------------------------------------------------------------------------------*/
	  int classPlayer=rmDefineClass("player");
	  rmDefineClass("startingUnit");
	  rmDefineClass("classHillArea");
	  rmDefineClass("socketClass");
	  rmDefineClass("importantItem");
	  rmDefineClass("nuggets");
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.20);
/*================================================================================================================*/
// ****************************************** DEFINE THE CONSTRAINTS: ******************************************* //
// ************************* THESE ARE USED TO HAVE OBJECTS AND AREAS AVOID EACH OTHER: ************************* **
/*================================================================================================================*/
// NONE FOR NOW:
/*----------------------------------------------------------------------------------------------------------------*/
      // MAP EDGE CONSTRAINTS:
      int playerEdgeConstraint=rmCreateBoxConstraint("player edge of map", rmXTilesToFraction(6), rmZTilesToFraction(6), 1.0-rmXTilesToFraction(6), 1.0-rmZTilesToFraction(6), 0.01);

      // PLAYER CONSTRAINTS:
      int playerConstraint=rmCreateClassDistanceConstraint("player vs. player", classPlayer, 10.0);
      int smallMapPlayerConstraint=rmCreateClassDistanceConstraint("stay away from players a lot", classPlayer, 70.0);
      int nuggetPlayerConstraint=rmCreateClassDistanceConstraint("nuggets stay away from players a lot", classPlayer, 40.0);

      // RESOURCE AVOIDANCE:
      int forestConstraint=rmCreateClassDistanceConstraint("forest vs. forest", rmClassID("classForest"), 25.0);
      int coinForestConstraint=rmCreateClassDistanceConstraint("coin vs. forest", rmClassID("classForest"), 15.0);
      int avoidBison=rmCreateTypeDistanceConstraint("bison avoids food", "bison", 40.0);
      int avoidPronghorn=rmCreateTypeDistanceConstraint("pronghorn avoids food", "pronghorn", 35.0);
	  int avoidCoin=rmCreateTypeDistanceConstraint("coin avoids coin", "gold", 35.0);
	  int avoidStartingCoin=rmCreateTypeDistanceConstraint("starting coin avoids coin", "gold", 22.0);
      int avoidNugget=rmCreateTypeDistanceConstraint("nugget avoid nugget", "AbstractNugget", 40.0);
      int avoidNuggetSmall=rmCreateTypeDistanceConstraint("avoid nuggets by a little", "AbstractNugget", 10.0);

	  int avoidFastCoin=-1;
	  if (cNumberNonGaiaPlayers >6)
	  {
		  avoidFastCoin=rmCreateTypeDistanceConstraint("fast coin avoids coin", "gold", rmXFractionToMeters(0.12));
	  }
	  else if (cNumberNonGaiaPlayers >4)
	  {
		  avoidFastCoin=rmCreateTypeDistanceConstraint("fast coin avoids coin", "gold", rmXFractionToMeters(0.14));
	  }
	  else
	  {
		  avoidFastCoin=rmCreateTypeDistanceConstraint("fast coin avoids coin", "gold", rmXFractionToMeters(0.16));
	  }

      // AVOID IMPASSABLE LAND:
      int avoidImpassableLand=rmCreateTerrainDistanceConstraint("avoid impassable land", "Land", false, 6.0);
      int shortAvoidImpassableLand=rmCreateTerrainDistanceConstraint("short avoid impassable land", "Land", false, 2.0);
      int patchConstraint=rmCreateClassDistanceConstraint("patch vs. patch", rmClassID("classPatch"), 5.0);

      // UNIT AVOIDANCE - FOR THINGS THAT AREN'T IN THE STARTING RESOURCES:
      int avoidStartingUnits=rmCreateClassDistanceConstraint("objects avoid starting units", rmClassID("startingUnit"), 30.0);
      int avoidStartingUnitsSmall=rmCreateClassDistanceConstraint("objects avoid starting units small", rmClassID("startingUnit"), 5.0);

      // DECORATION AVOIDANCE:
      int avoidAll=rmCreateTypeDistanceConstraint("avoid all", "all", 6.0);

      // VP AVOIDANCE:
      int avoidTradeRoute = rmCreateTradeRouteDistanceConstraint("trade route", 6.0);
      int avoidTradeRouteSmall = rmCreateTradeRouteDistanceConstraint("trade route small", 4.0);
      //int avoidTradeRoutePlayer = rmCreateTradeRouteDistanceConstraint("trade route player", 30.0);
      
	  // IMPORTANT ITEM AVOIDANCE:
	  int avoidImportantItem=rmCreateClassDistanceConstraint("important stuff avoids each other", rmClassID("importantItem"), 15.0);

	  // SOCKET AVOIDANCE:
	  int avoidSocket=rmCreateClassDistanceConstraint("socket avoidance", rmClassID("socketClass"), 8.0);
	  int avoidSocketMore=rmCreateClassDistanceConstraint("bigger socket avoidance", rmClassID("socketClass"), 15.0);

      // CONSTRAINT TO AVOID WATER:
      int avoidWater4 = rmCreateTerrainDistanceConstraint("avoid water", "Land", false, 4.0);
      int avoidWater20 = rmCreateTerrainDistanceConstraint("avoid water medium", "Land", false, 20.0);
      int avoidWater40 = rmCreateTerrainDistanceConstraint("avoid water long", "Land", false, 40.0);

	  // AVOID THE HILLY AREAS:
	  int avoidHills = rmCreateClassDistanceConstraint("avoid Hills", rmClassID("classHillArea"), 5.0);
	
	  // NATIVES AVOID NATIVES:
	  int avoidNatives = rmCreateClassDistanceConstraint("avoid Natives", rmClassID("natives"), 40.0);
	  int avoidNativesNuggets = rmCreateClassDistanceConstraint("nuggets avoid Natives", rmClassID("natives"), 20.0);

	  // CIRCLE CONSTRAINT:
	  int circleConstraint=rmCreatePieConstraint("circle Constraint", 0.5, 0.5, 0, rmZFractionToMeters(0.47), rmDegreesToRadians(0), rmDegreesToRadians(360)); 
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.25);
/*================================================================================================================*/
// ************************************* DEFINE THE TRADE ROUTE PLACEMENT: ************************************** //
/*================================================================================================================*/
// NONE FOR NOW:
/*----------------------------------------------------------------------------------------------------------------*/
      // DEFINE AND PLACE THE TRADE ROUTE:
	  int tradeRouteID = rmCreateTradeRoute();
      int socketID=rmCreateObjectDef("sockets to dock Trade Posts south");
      rmSetObjectDefTradeRouteID(socketID, tradeRouteID);

      rmAddObjectDefItem(socketID, "SocketTradeRoute", 1, 0.0);
      rmSetObjectDefAllowOverlap(socketID, true);
      rmAddObjectDefToClass(socketID, rmClassID("socketClass"));
      rmSetObjectDefMinDistance(socketID, 0.0);
      rmSetObjectDefMaxDistance(socketID, 12.0);

	  rmAddTradeRouteWaypoint(tradeRouteID, 0.6, 0.95);
	  rmAddTradeRouteWaypoint(tradeRouteID, 0.4, 0.05);
	  
      bool placedTradeRoute = rmBuildTradeRoute(tradeRouteID, "dirt");
      if(placedTradeRoute == false)
      rmEchoError("Failed to place trade route"); 
/*================================================================================================================*/  
	  // ADD THE SOCKETS ALONG THE TRADE ROUTE:
      vector socketLoc = rmGetTradeRouteWayPoint(tradeRouteID, 0.05);
      rmPlaceObjectDefAtPoint(socketID, 0, socketLoc);
	  
	  socketLoc = rmGetTradeRouteWayPoint(tradeRouteID, 0.35);
      rmPlaceObjectDefAtPoint(socketID, 0, socketLoc);
	  
	  socketLoc = rmGetTradeRouteWayPoint(tradeRouteID, 0.65);
      rmPlaceObjectDefAtPoint(socketID, 0, socketLoc);

      socketLoc = rmGetTradeRouteWayPoint(tradeRouteID, 0.95);
      rmPlaceObjectDefAtPoint(socketID, 0, socketLoc);
/*================================================================================================================*/	  
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.30);
/*================================================================================================================*/
// ******************************************** DEFINE THE AREAS: *********************************************** //
/*================================================================================================================*/
// ************************************* SET UP PLAYER STARTING LOCATIONS: ************************************** //
/*================================================================================================================*/
  	if ( cNumberTeams == 2 )
/*----------------------------------------------------------------------------------------------------------------*/	
	{
/*----------------------------------------------------------------------------------------------------------------*/	
		rmSetPlacementTeam(0);
		rmSetPlacementSection(0.15, 0.35);
		if (cNumberNonGaiaPlayers >6)
		{
			rmSetPlacementSection(0.13, 0.37);
		}
		rmPlacePlayersCircular(0.35, 0.40, 0.0);
		   

		rmSetPlacementTeam(1);
		rmSetPlacementSection(0.65, 0.85);
		if (cNumberNonGaiaPlayers >6)
		{
			rmSetPlacementSection(0.63, 0.87);
		}
		rmPlacePlayersCircular(0.35, 0.40, 0.0);
/*----------------------------------------------------------------------------------------------------------------*/		   
	}
/*----------------------------------------------------------------------------------------------------------------*/	
	else
/*----------------------------------------------------------------------------------------------------------------*/	
	{
  		rmSetPlacementSection(0.0, 0.95);
		rmPlacePlayersCircular(0.40, 0.42, 0.0);
	}   
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.35);
/*================================================================================================================*/
// ****************************************** SET UP PLAYER AREAS: ********************************************** //
/*================================================================================================================*/
   float playerFraction=rmAreaTilesToFraction(100);
/*----------------------------------------------------------------------------------------------------------------*/
   for(i=1; <cNumberPlayers)
/*----------------------------------------------------------------------------------------------------------------*/
   {
/*----------------------------------------------------------------------------------------------------------------*/   
      // CREATE THE AREA:
      int id=rmCreateArea("Player"+i);
      
	  // ASSIGN TO THE PLAYER:
      rmSetPlayerArea(i, id);
      
	  // SET THE SIZE:
      rmSetAreaSize(id, playerFraction, playerFraction);
      
	  // ADD AREA TO CLASS:
	  rmAddAreaToClass(id, classPlayer);
      
	  // SET AREA MIN AND MAX BLOBS:
	  rmSetAreaMinBlobs(id, 1);
      rmSetAreaMaxBlobs(id, 1);
      
	  // ADD AREA CONSTRAINTS:
	  rmAddAreaConstraint(id, playerConstraint); 
      rmAddAreaConstraint(id, playerEdgeConstraint); 
	  //rmAddAreaConstraint(id, avoidTradeRoute); 
      
	  // SET AREA LOC PLAYER:
	  rmSetAreaLocPlayer(id, i);
	  
	  // SET AREA TERRAIN TYPE:
	  rmSetAreaTerrainType(id, "texas\groundforestdirt_tex");
      
	  // SET AREA WARN FAILURE:
	  rmSetAreaWarnFailure(id, false);
/*----------------------------------------------------------------------------------------------------------------*/	  
   }
/*----------------------------------------------------------------------------------------------------------------*/
      // Build the areas.
      //rmBuildAllAreas();
	  
	  // BUILD THE AREA:
	  rmBuildArea(id);      
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.40);
/*================================================================================================================*/
// ****************************** VARIABLES NEEDED BY THE HILLS AND THE FORESTS: ******************************** //
/*================================================================================================================*/
	// TEXT:
	int numTries = -1;
	int failCount = -1;
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.45);
/*================================================================================================================*/
// ******************************************** TWO HILLY AREAS: ************************************************ //
/*================================================================================================================*/
// NONE FOR NOW:
/*----------------------------------------------------------------------------------------------------------------*/
/*================================================================================================================*/
// ******************************************** TWO HILLY AREAS: ************************************************ //
/*================================================================================================================*/
      int hillNorthwestID=rmCreateArea("northwest hills");
      int avoidNW = rmCreateAreaDistanceConstraint("avoid nw", hillNorthwestID, 3.0);
/*----------------------------------------------------------------------------------------------------------------*/
      rmSetAreaSize(hillNorthwestID, 0.2, 0.2);
      rmSetAreaWarnFailure(hillNorthwestID, false);
      rmSetAreaSmoothDistance(hillNorthwestID, 10);
	  rmSetAreaMix(hillNorthwestID, "sonora_dirt");
	  rmSetAreaElevationType(hillNorthwestID, cElevTurbulence);
      rmSetAreaElevationVariation(hillNorthwestID, 6.0);
      rmSetAreaBaseHeight(hillNorthwestID, 5);
      rmSetAreaElevationMinFrequency(hillNorthwestID, 0.05);
      rmSetAreaElevationOctaves(hillNorthwestID, 3);
      rmSetAreaElevationPersistence(hillNorthwestID, 0.3);      
      rmSetAreaElevationNoiseBias(hillNorthwestID, 0.5);
      rmSetAreaElevationEdgeFalloffDist(hillNorthwestID, 20.0);
	  rmSetAreaCoherence(hillNorthwestID, 0.9);
	  rmSetAreaLocation(hillNorthwestID, 0.2, 0.8);
      rmSetAreaEdgeFilling(hillNorthwestID, 5);
	  rmAddAreaInfluenceSegment(hillNorthwestID, 0.05, 0.60, 0.4, 0.95);
	  rmSetAreaHeightBlend(hillNorthwestID, 1);
	  rmSetAreaObeyWorldCircleConstraint(hillNorthwestID, false);
	  rmAddAreaToClass(hillNorthwestID, rmClassID("classHillArea"));
	  rmBuildArea(hillNorthwestID);
/*----------------------------------------------------------------------------------------------------------------*/
      int hillSoutheastID=rmCreateArea("southeast hills");
      int avoidSE = rmCreateAreaDistanceConstraint("avoid se", hillSoutheastID, 3.0);
/*----------------------------------------------------------------------------------------------------------------*/
      rmSetAreaSize(hillSoutheastID, 0.2, 0.2);
      rmSetAreaWarnFailure(hillSoutheastID, false);
      rmSetAreaSmoothDistance(hillSoutheastID, 10);
	  rmSetAreaMix(hillSoutheastID, "sonora_dirt");
	  rmSetAreaElevationType(hillSoutheastID, cElevTurbulence);
      rmSetAreaElevationVariation(hillSoutheastID, 6.0);
      rmSetAreaBaseHeight(hillSoutheastID, 5);
      rmSetAreaElevationMinFrequency(hillSoutheastID, 0.05);
      rmSetAreaElevationOctaves(hillSoutheastID, 3);
      rmSetAreaElevationPersistence(hillSoutheastID, 0.3);
      rmSetAreaElevationNoiseBias(hillSoutheastID, 0.5);
      rmSetAreaElevationEdgeFalloffDist(hillSoutheastID, 20.0);
	  rmSetAreaCoherence(hillSoutheastID, 0.9);
	  rmSetAreaLocation(hillSoutheastID, 0.8, 0.2);
      rmSetAreaEdgeFilling(hillSoutheastID, 5);
	  rmAddAreaInfluenceSegment(hillSoutheastID, 0.6, 0.05, 0.95, 0.4);
	  rmSetAreaHeightBlend(hillSoutheastID, 1);
	  rmSetAreaObeyWorldCircleConstraint(hillSoutheastID, false);
	  rmAddAreaToClass(hillSoutheastID, rmClassID("classHillArea"));
	  rmBuildArea(hillSoutheastID);
/*================================================================================================================*/	  
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.50);
/*================================================================================================================*/
// ********************************* PLACEMENT ORDER OF NON-TRADE ROUTE STUFF: ********************************** //
// ***************************** NATIVES -> SECRETS -> NUGGETS -> SMALL PONDS (WHEE): *************************** //
/*================================================================================================================*/
// ************************************* STARTING UNITS and RESOURCES DEFS ************************************** //
/*================================================================================================================*/
	  // DEFINE THE STARTING TCID AND STARTING UNITS:
	  int startingUnits = rmCreateStartingUnitsObjectDef(5.0);
	  rmSetObjectDefMinDistance(startingUnits, 7.0);
	  rmSetObjectDefMaxDistance(startingUnits, 12.0);

	  int startingTCID = rmCreateObjectDef("startingTC");
	  if ( rmGetNomadStart())
	  {
		  rmAddObjectDefItem(startingTCID, "CoveredWagon", 1, 0.0);
	  }
	  else
	  {
		  rmAddObjectDefItem(startingTCID, "TownCenter", 1, 0.0);
	  }
	  rmAddObjectDefToClass(startingTCID, rmClassID("startingUnit"));
	  rmSetObjectDefMinDistance(startingTCID, 0.0);
	  rmSetObjectDefMaxDistance(startingTCID, 9.0);
	  //rmAddObjectDefConstraint(startingTCID, avoidTradeRouteSmall);

	  // rmAddObjectDefConstraint(startingTCID, avoidTradeRoute);
/*----------------------------------------------------------------------------------------------------------------*/	  
// ************************************ DEFINE THE STARTING RESOURCES: ****************************************** //
/*================================================================================================================*/
// NONE FOR NOW:
/*----------------------------------------------------------------------------------------------------------------*/
	  // DEFINE THE STARTING TREES:
	  int StartAreaTreeID=rmCreateObjectDef("starting trees");
	  // rmAddObjectDefItem(StartAreaTreeID, "TreeGreatPlains", 1, 0.0);
	     rmAddObjectDefItem(StartAreaTreeID, "TreeTexasDirt", 1, 0.0);
	  rmSetObjectDefMinDistance(StartAreaTreeID, 12.0);
	  rmSetObjectDefMaxDistance(StartAreaTreeID, 18.0);
	  rmAddObjectDefConstraint(StartAreaTreeID, avoidStartingUnitsSmall);

	  // DEFINE THE STARTING BISONS:
	  int StartBisonID=rmCreateObjectDef("starting bison");
	  rmAddObjectDefItem(StartBisonID, "Bison", 4, 4.0);
	  rmSetObjectDefMinDistance(StartBisonID, 10.0);
	  rmSetObjectDefMaxDistance(StartBisonID, 12.0);
	  rmSetObjectDefCreateHerd(StartBisonID, true);
	  rmAddObjectDefConstraint(StartBisonID, avoidStartingUnitsSmall);

	  // DEFINE THE PLAYER NUGGETS:
	  int playerNuggetID=rmCreateObjectDef("player nugget");
	  rmAddObjectDefItem(playerNuggetID, "nugget", 1, 0.0);
	  rmAddObjectDefToClass(playerNuggetID, rmClassID("nuggets"));
	  rmAddObjectDefToClass(playerNuggetID, rmClassID("startingUnit"));
      rmSetObjectDefMinDistance(playerNuggetID, 28.0);
      rmSetObjectDefMaxDistance(playerNuggetID, 35.0);
	  rmAddObjectDefConstraint(playerNuggetID, avoidNugget);
	  rmAddObjectDefConstraint(playerNuggetID, avoidNativesNuggets);
	  rmAddObjectDefConstraint(playerNuggetID, avoidTradeRouteSmall);
	  rmAddObjectDefConstraint(playerNuggetID, circleConstraint);
	  //rmAddObjectDefConstraint(playerNuggetID, avoidImportantItem);

	  // VARIABLE FOR THE STARTING SILVER MINES: 
	  int silverType = -1;
	  int playerGoldID = -1;	  
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.55);
/*================================================================================================================*/
// ***************************** PLACE THE STARTING TCID AND THE STARTING UNITS: ******************************** //
/*================================================================================================================*/
 	    for(i=1; <cNumberPlayers)
/*----------------------------------------------------------------------------------------------------------------*/		
	{
/*----------------------------------------------------------------------------------------------------------------*/	
		rmPlaceObjectDefAtLoc(startingTCID, i, rmPlayerLocXFraction(i), rmPlayerLocZFraction(i));
		rmPlaceObjectDefAtLoc(startingUnits, i, rmPlayerLocXFraction(i), rmPlayerLocZFraction(i));
/*----------------------------------------------------------------------------------------------------------------*/
		
/*================================================================================================================*/
// ************************************* PLACE THE STARTING RESOURCES: ****************************************** //
/*================================================================================================================*/
// NONE FOR NOW:
/*----------------------------------------------------------------------------------------------------------------*/
// EVERYONE GETS TWO ORE OBJECTDEFS, ONE PRETTY CLOSE, THE OTHER A LITTLE FURTHER AWAY:
		silverType = rmRandInt(1,10);
		playerGoldID = rmCreateObjectDef("player silver closer "+i);
		rmAddObjectDefItem(playerGoldID, "mine", 1, 0.0);
		// rmAddObjectDefToClass(playerGoldID, rmClassID("importantItem"));
		rmAddObjectDefConstraint(playerGoldID, avoidTradeRoute);
		rmAddObjectDefConstraint(playerGoldID, avoidStartingCoin);
		rmAddObjectDefConstraint(playerGoldID, avoidStartingUnitsSmall);
		rmSetObjectDefMinDistance(playerGoldID, 15.0);
		rmSetObjectDefMaxDistance(playerGoldID, 20.0);
				
		// PLACE TWO GOLD MINES:
		rmPlaceObjectDefAtLoc(playerGoldID, 0, rmPlayerLocXFraction(i), rmPlayerLocZFraction(i));
		rmPlaceObjectDefAtLoc(playerGoldID, 0, rmPlayerLocXFraction(i), rmPlayerLocZFraction(i));

		// PLACING THE STARTING TREES:
		rmPlaceObjectDefAtLoc(StartAreaTreeID, 0, rmPlayerLocXFraction(i), rmPlayerLocZFraction(i));
		rmPlaceObjectDefAtLoc(StartAreaTreeID, 0, rmPlayerLocXFraction(i), rmPlayerLocZFraction(i));
		rmPlaceObjectDefAtLoc(StartAreaTreeID, 0, rmPlayerLocXFraction(i), rmPlayerLocZFraction(i));
		rmPlaceObjectDefAtLoc(StartAreaTreeID, 0, rmPlayerLocXFraction(i), rmPlayerLocZFraction(i));
		rmPlaceObjectDefAtLoc(StartAreaTreeID, 0, rmPlayerLocXFraction(i), rmPlayerLocZFraction(i));
		rmPlaceObjectDefAtLoc(StartAreaTreeID, 0, rmPlayerLocXFraction(i), rmPlayerLocZFraction(i));

		// PLACING THE STARTING BISONS:
		rmPlaceObjectDefAtLoc(StartBisonID, 0, rmPlayerLocXFraction(i), rmPlayerLocZFraction(i));

		// PLACING THE PLAYER NUGGETS:
		rmSetNuggetDifficulty(1, 1);
		rmPlaceObjectDefAtLoc(playerNuggetID, 0, rmPlayerLocXFraction(i), rmPlayerLocZFraction(i));
		rmPlaceObjectDefAtLoc(playerNuggetID, 0, rmPlayerLocXFraction(i), rmPlayerLocZFraction(i));
/*----------------------------------------------------------------------------------------------------------------*/		
	}
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.60);
/*================================================================================================================*/
// *********************************** DEFINE AND PLACE THE NATIVE AMERICANS: *********************************** //
/*================================================================================================================*/
// NONE FOR NOW:
/*----------------------------------------------------------------------------------------------------------------*/
	    if (subCiv0 == rmGetCivID("Comanche"))
	{  
		int comancheVillageID = -1;
		comancheVillageID = rmCreateGrouping("comanche village 1", "native comanche village 1");
		rmSetGroupingMinDistance(comancheVillageID, 0.0);
		// rmSetGroupingMaxDistance(comancheVillageID, rmXFractionToMeters(0.5));
		   rmSetGroupingMaxDistance(comancheVillageID, 0.0);
		rmAddGroupingConstraint(comancheVillageID, avoidImpassableLand);
		rmAddGroupingToClass(comancheVillageID, rmClassID("importantItem"));
		rmAddGroupingConstraint(comancheVillageID, avoidImportantItem);
		//rmAddGroupingConstraint(comancheVillageID, insideCircleConstraint);
		rmPlaceGroupingAtLoc(comancheVillageID, 0, 0.71, 0.865);
	} 
/*----------------------------------------------------------------------------------------------------------------*/
        if (subCiv1 == rmGetCivID("Comanche"))
	{  
		int comancheVillage2ID = -1;
		comancheVillage2ID = rmCreateGrouping("comanche village 2", "native comanche village 1");
		rmSetGroupingMinDistance(comancheVillage2ID, 0.0);
		// rmSetGroupingMaxDistance(comancheVillage2ID, rmXFractionToMeters(0.5));
		   rmSetGroupingMaxDistance(comancheVillage2ID, 0.0);
		rmAddGroupingConstraint(comancheVillage2ID, avoidImpassableLand);
		rmAddGroupingToClass(comancheVillage2ID, rmClassID("importantItem"));
		rmAddGroupingConstraint(comancheVillage2ID, avoidImportantItem);
		//rmAddGroupingConstraint(comancheVillage2ID, insideCircleConstraint);
		rmPlaceGroupingAtLoc(comancheVillage2ID, 0, 0.325, 0.11);
	} 
/*----------------------------------------------------------------------------------------------------------------*/
        if (subCiv2 == rmGetCivID("Comanche"))
	{  
		int comancheVillage3ID = -1;
		comancheVillage3ID = rmCreateGrouping("comanche village 3", "native comanche village 1");
		rmSetGroupingMinDistance(comancheVillage3ID, 0.0);
		// rmSetGroupingMaxDistance(comancheVillage3ID, rmXFractionToMeters(0.5));
		   rmSetGroupingMaxDistance(comancheVillage3ID, 0.0);
		rmAddGroupingConstraint(comancheVillage3ID, avoidImpassableLand);
		rmAddGroupingToClass(comancheVillage3ID, rmClassID("importantItem"));
		rmAddGroupingConstraint(comancheVillage3ID, avoidImportantItem);
		//rmAddGroupingConstraint(comancheVillage3ID, insideCircleConstraint);
		rmPlaceGroupingAtLoc(comancheVillage3ID, 0, 0.8, 0.3);
	} 
/*----------------------------------------------------------------------------------------------------------------*/
        if (subCiv3 == rmGetCivID("Comanche"))
	{  
		int comancheVillage4ID = -1;
		comancheVillage4ID = rmCreateGrouping("comanche village 4", "native comanche village 1");
		rmSetGroupingMinDistance(comancheVillage4ID, 0.0);
		// rmSetGroupingMaxDistance(comancheVillage4ID, rmXFractionToMeters(0.5));
		   rmSetGroupingMaxDistance(comancheVillage4ID, 0.0);
		rmAddGroupingConstraint(comancheVillage4ID, avoidImpassableLand);
		rmAddGroupingToClass(comancheVillage4ID, rmClassID("importantItem"));
		rmAddGroupingConstraint(comancheVillage4ID, avoidImportantItem);
		//rmAddGroupingConstraint(comancheVillage4ID, insideCircleConstraint);
		rmPlaceGroupingAtLoc(comancheVillage4ID, 0, 0.3, 0.8);
	} 	

/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.65);
/*================================================================================================================*/
// ************************************** DEFINE AND PLACE THE NUGGETS: ***************************************** //
/*================================================================================================================*/
// NONE FOR NOW:
/*----------------------------------------------------------------------------------------------------------------*/
    int nuggetID= rmCreateObjectDef("nugget"); 
	rmAddObjectDefItem(nuggetID, "Nugget", 1, 0.0);
	rmSetObjectDefMinDistance(nuggetID, 0.0);
	rmSetObjectDefMaxDistance(nuggetID, rmXFractionToMeters(0.5));
	rmAddObjectDefConstraint(nuggetID, shortAvoidImpassableLand);
  	rmAddObjectDefConstraint(nuggetID, avoidNugget);
	rmAddObjectDefConstraint(nuggetID, nuggetPlayerConstraint);
  	rmAddObjectDefConstraint(nuggetID, playerConstraint);
  	rmAddObjectDefConstraint(nuggetID, avoidTradeRoute);
	rmAddObjectDefConstraint(nuggetID, avoidImportantItem);
	rmAddObjectDefConstraint(nuggetID, avoidSocketMore);
	rmAddObjectDefConstraint(nuggetID, avoidNativesNuggets);
	rmAddObjectDefConstraint(nuggetID, circleConstraint);
  	rmAddObjectDefConstraint(nuggetID, avoidAll);
	rmSetNuggetDifficulty(1, 3);
/*----------------------------------------------------------------------------------------------------------------*/	
	rmPlaceObjectDefAtLoc(nuggetID, 0, 0.5, 0.5, cNumberNonGaiaPlayers*4);
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.70);
/*================================================================================================================*/
// ************************************** DEFINE AND PLACE THE RESOURCES: *************************************** //
/*================================================================================================================*/
// ************************ FAST COIN - THREE EXTRA PER PLAYER BEYOND STARTING RESOURCES: *********************** //
/*================================================================================================================*/
	    int silverID = -1;
	    // int silverCount = (cNumberNonGaiaPlayers*3);
		   int silverCount = (cNumberNonGaiaPlayers*3);
	    rmEchoInfo("silver count = "+silverCount);
/*----------------------------------------------------------------------------------------------------------------*/
	    for(i=0; < silverCount)
/*----------------------------------------------------------------------------------------------------------------*/
	{
/*----------------------------------------------------------------------------------------------------------------*/	
		silverType = rmRandInt(1,10);
		silverID = rmCreateObjectDef("silver "+i);
		rmAddObjectDefItem(silverID, "mine", 1, 0.0);
		rmAddObjectDefToClass(silverID, rmClassID("importantItem"));
		rmSetObjectDefMinDistance(silverID, 0.0);
		rmSetObjectDefMaxDistance(silverID, rmXFractionToMeters(0.5));
/*----------------------------------------------------------------------------------------------------------------*/		
		rmAddObjectDefConstraint(silverID, avoidFastCoin);
		rmAddObjectDefConstraint(silverID, avoidAll);
		rmAddObjectDefConstraint(silverID, avoidImpassableLand);
		rmAddObjectDefConstraint(silverID, avoidImportantItem);
		rmAddObjectDefConstraint(silverID, avoidTradeRoute);
		rmAddObjectDefConstraint(silverID, avoidSocket);
		rmAddObjectDefConstraint(silverID, coinForestConstraint);
		rmAddObjectDefConstraint(silverID, avoidStartingUnits);
		rmAddObjectDefConstraint(silverID, avoidNuggetSmall);
/*----------------------------------------------------------------------------------------------------------------*/		
		int result = rmPlaceObjectDefAtLoc(silverID, 0, 0.5, 0.5);
		if(result == 0)
			break;
/*----------------------------------------------------------------------------------------------------------------*/			
   }
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.75);
/*================================================================================================================*/
// ************************************ DEFINE AND PLACE THE BISONS: ******************************************** //
/*================================================================================================================*/
      int bisonID=rmCreateObjectDef("bison herd");
      rmAddObjectDefItem(bisonID, "bison", rmRandInt(12,16), 12.0);
      rmSetObjectDefMinDistance(bisonID, 0.0);
      rmSetObjectDefMaxDistance(bisonID, rmXFractionToMeters(0.5));
/*----------------------------------------------------------------------------------------------------------------*/	  
      rmAddObjectDefConstraint(bisonID, avoidBison);
	  rmAddObjectDefConstraint(bisonID, avoidAll);
      rmAddObjectDefConstraint(bisonID, avoidImpassableLand);
	  rmAddObjectDefConstraint(bisonID, avoidImportantItem);
	  rmAddObjectDefConstraint(bisonID, avoidTradeRoute);
	  rmAddObjectDefConstraint(bisonID, avoidSocket);
	  rmAddObjectDefConstraint(bisonID, avoidStartingUnits);
	  rmAddObjectDefConstraint(bisonID, avoidNuggetSmall);
/*----------------------------------------------------------------------------------------------------------------*/	  
      rmSetObjectDefCreateHerd(bisonID, true);
	  rmPlaceObjectDefAtLoc(bisonID, 0, 0.5, 0.5, cNumberNonGaiaPlayers*3);
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.79);
/*================================================================================================================*/
// ************************************* DEFINE AND PLACE THE PROGHORN: ***************************************** //
/*================================================================================================================*/
	  int pronghornID=rmCreateObjectDef("pronghorn herd");
      rmAddObjectDefItem(pronghornID, "pronghorn", rmRandInt(6,9), 10.0);
      rmSetObjectDefMinDistance(pronghornID, 0.0);
      rmSetObjectDefMaxDistance(pronghornID, rmXFractionToMeters(0.5));
/*----------------------------------------------------------------------------------------------------------------*/	  
      rmAddObjectDefConstraint(pronghornID, avoidBison);
      rmAddObjectDefConstraint(pronghornID, avoidPronghorn);
	  rmAddObjectDefConstraint(pronghornID, avoidAll);
	  rmAddObjectDefConstraint(pronghornID, avoidImportantItem);
      rmAddObjectDefConstraint(pronghornID, avoidImpassableLand);
	  rmAddObjectDefConstraint(pronghornID, avoidTradeRoute);
	  rmAddObjectDefConstraint(pronghornID, avoidSocket);
	  rmAddObjectDefConstraint(pronghornID, avoidStartingUnits);
	  rmAddObjectDefConstraint(pronghornID, avoidNuggetSmall);
/*----------------------------------------------------------------------------------------------------------------*/	  
      rmSetObjectDefCreateHerd(pronghornID, true);
	  rmPlaceObjectDefAtLoc(pronghornID, 0, 0.5, 0.5, cNumberNonGaiaPlayers*2);
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.80);
/*================================================================================================================*/
// ************************************ DEFINE AND PLACE THE SE TREES: ****************************************** //
/*================================================================================================================*/
        int seConstraint = rmCreateAreaConstraint("se", hillSoutheastID);
        int heightConstraint = rmCreateMaxHeightConstraint("tree height", 6.0);
        int lowForestClass = rmDefineClass("low forest");
        int lowForestConstraint = rmCreateClassDistanceConstraint("low forest", lowForestClass, 4.0);
/*----------------------------------------------------------------------------------------------------------------*/
        // RANDOM TREES:
        int count = 0;
        int maxCount = 20 * cNumberNonGaiaPlayers;
        int maxFailCount = 10 * cNumberNonGaiaPlayers;
        failCount = 0;
/*----------------------------------------------------------------------------------------------------------------*/		
        for(i=1; <10)
/*----------------------------------------------------------------------------------------------------------------*/		
   {
/*----------------------------------------------------------------------------------------------------------------*/   
		int treeArea = rmCreateArea("se tree"+i);
		rmSetAreaSize(treeArea, 0.001, 0.003);
		rmSetAreaForestType(treeArea, "texas forest dirt");
		rmSetAreaForestDensity(treeArea, 0.8);
		rmSetAreaForestClumpiness(treeArea, 0.1);
/*----------------------------------------------------------------------------------------------------------------*/		
		rmAddAreaConstraint(treeArea, seConstraint);
		rmAddAreaConstraint(treeArea, lowForestConstraint);
		rmAddAreaConstraint(treeArea, heightConstraint);
		rmAddAreaConstraint(treeArea, avoidImpassableLand);
		rmAddAreaConstraint(treeArea, avoidImportantItem);
		rmAddAreaConstraint(treeArea, avoidTradeRoute);
		rmAddAreaConstraint(treeArea, avoidSocket);
		rmAddAreaConstraint(treeArea, avoidStartingUnits);
		rmAddAreaConstraint(treeArea, avoidAll);
		rmAddAreaConstraint(treeArea, avoidNuggetSmall);
/*----------------------------------------------------------------------------------------------------------------*/		
		rmAddAreaToClass(treeArea, lowForestClass);
/*----------------------------------------------------------------------------------------------------------------*/		
		rmSetAreaWarnFailure(treeArea, false);
/*----------------------------------------------------------------------------------------------------------------*/		
		bool ok = rmBuildArea(treeArea);
		if(ok)
		{
			count++;
			if(count > maxCount)
			break;
		}
		else
		{
			failCount++;
			if(failCount > maxFailCount)
			break;
		}
/*----------------------------------------------------------------------------------------------------------------*/		
   }
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.85);
/*================================================================================================================*/
// ************************************ DEFINE AND PLACE THE NW TREES: ****************************************** //
/*================================================================================================================*/
       int nwConstraint = rmCreateAreaConstraint("nw", hillNorthwestID);
/*----------------------------------------------------------------------------------------------------------------*/	   
       int maxAreas = 5 * cNumberNonGaiaPlayers;
       int maxFails = 5 * cNumberNonGaiaPlayers;
       count = 0;
       failCount = 0;
/*----------------------------------------------------------------------------------------------------------------*/	   
       for(i=1; <10)
/*----------------------------------------------------------------------------------------------------------------*/	   
   {
/*----------------------------------------------------------------------------------------------------------------*/   
       treeArea = rmCreateArea("nw tree"+i);
       rmSetAreaSize(treeArea, 0.001, 0.003);
	   rmSetAreaForestType(treeArea, "texas forest dirt");
	   rmSetAreaForestDensity(treeArea, 0.8);
	   rmSetAreaForestClumpiness(treeArea, 0.1);
/*----------------------------------------------------------------------------------------------------------------*/	   
	   rmAddAreaConstraint(treeArea, nwConstraint);
	   rmAddAreaConstraint(treeArea, lowForestConstraint);
	   rmAddAreaConstraint(treeArea, heightConstraint);
	   rmAddAreaConstraint(treeArea, avoidImpassableLand);
	   rmAddAreaConstraint(treeArea, avoidImportantItem);
	   rmAddAreaConstraint(treeArea, avoidTradeRoute);
	   rmAddAreaConstraint(treeArea, avoidSocket);
	   rmAddAreaConstraint(treeArea, avoidStartingUnits);
	   rmAddAreaConstraint(treeArea, avoidAll);
	   rmAddAreaConstraint(treeArea, avoidNuggetSmall);
/*----------------------------------------------------------------------------------------------------------------*/	   
	   rmAddAreaToClass(treeArea, lowForestClass);
	   rmSetAreaWarnFailure(treeArea, false);
/*----------------------------------------------------------------------------------------------------------------*/	   
      ok = rmBuildArea(treeArea);
      if(ok)
      {
         count++;
         if(count > maxCount)
            break;
      }
      else
      {
         failCount++;
         if(failCount > maxFailCount)
            break;
      }
/*----------------------------------------------------------------------------------------------------------------*/	  
   }
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.90);
/*================================================================================================================*/
// *********************** DEFINE AND PLACE THE MINI-FORESTS OUT ON THE PLAINS (MOSTLY): ************************ //
/*================================================================================================================*/
       
        int forestTreeID = 0;
		
        numTries=5*cNumberNonGaiaPlayers;
        failCount=0;
		
        for (i=0; <numTries)
		
   {  
   
		int forest=rmCreateArea("center forest "+i);
		rmSetAreaWarnFailure(forest, false);
		rmSetAreaSize(forest, rmAreaTilesToFraction(100), rmAreaTilesToFraction(100));
		rmSetAreaForestType(forest, "texas forest");
		rmSetAreaForestDensity(forest, 0.9);
		rmSetAreaForestClumpiness(forest, 0.8);
		rmSetAreaForestUnderbrush(forest, 0.0);
		rmSetAreaCoherence(forest, 0.5);
		// rmSetAreaSmoothDistance(forest, 10);
		rmAddAreaToClass(forest, rmClassID("classForest")); 
		
		rmAddAreaConstraint(forest, lowForestConstraint);
		rmAddAreaConstraint(forest, forestConstraint);
		rmAddAreaConstraint(forest, playerConstraint);
		rmAddAreaConstraint(forest, avoidImportantItem);
		rmAddAreaConstraint(forest, avoidImpassableLand); 
		rmAddAreaConstraint(forest, avoidTradeRoute);
		rmAddAreaConstraint(forest, avoidSocket);
		rmAddAreaConstraint(forest, avoidHills);
		//rmAddAreaConstraint(forest, avoidNuggetSmall);
		// rmAddAreaConstraint(forest, avoidFastCoin); // REMOVED BY ENSEMBLE
		rmAddAreaConstraint(forest, avoidStartingUnits);
		
		if(rmBuildArea(forest)==false)
		{
			// Stop trying once we fail 10 times in a row.
			failCount++;
			if(failCount==10)
			break;
		}
		else
			failCount=0; 
			
   }

/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.95);
/*================================================================================================================*/
// *********************** DEFINE AND PLACE PERCHING VULTURES - ADD A COUPLE SOMEWHERE: ************************* //
/*================================================================================================================*/	  
	  int vultureID=rmCreateObjectDef("perching vultures");
	  rmAddObjectDefItem(vultureID, "PropVulturePerching", 1, 0.0);
	  rmSetObjectDefMinDistance(vultureID, 0.0);
	  rmSetObjectDefMaxDistance(vultureID, rmXFractionToMeters(0.5));
	  rmAddObjectDefConstraint(vultureID, avoidNW);
	  rmAddObjectDefConstraint(vultureID, avoidSE);
	  rmAddObjectDefConstraint(vultureID, avoidBison);
	  rmAddObjectDefConstraint(vultureID, avoidAll);
	  rmAddObjectDefConstraint(vultureID, avoidNuggetSmall);
	  rmAddObjectDefConstraint(vultureID, avoidImpassableLand);
	  rmAddObjectDefConstraint(vultureID, avoidTradeRoute);
	  rmAddObjectDefConstraint(vultureID, avoidSocket);
	  rmAddObjectDefConstraint(vultureID, avoidStartingUnits);
	  rmAddObjectDefConstraint(vultureID, circleConstraint);
	  rmAddObjectDefConstraint(vultureID, playerConstraint);
	  rmPlaceObjectDefAtLoc(vultureID, 0, 0.5, 0.5, 2);
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.98);
/*================================================================================================================*/
// ********************************* DEFINE AND PLACE  A COUPLE OF GEYSERS: ************************************* //
/*================================================================================================================*/
	    int geyserID=rmCreateGrouping("Geysers", "prop_geyser");
	    rmSetGroupingMinDistance(geyserID, 0.0);
	    rmSetGroupingMaxDistance(geyserID, rmXFractionToMeters(0.5));
	    rmAddGroupingConstraint(geyserID, avoidNW);
	    rmAddGroupingConstraint(geyserID, avoidSE);
	    rmAddGroupingConstraint(geyserID, avoidBison);
	    rmAddGroupingConstraint(geyserID, avoidAll);
	    rmAddGroupingConstraint(geyserID, avoidImpassableLand);
	    rmAddGroupingConstraint(geyserID, avoidTradeRoute);
	    rmAddGroupingConstraint(geyserID, avoidSocket);
	    rmAddGroupingConstraint(geyserID, avoidStartingUnits);
	    rmAddGroupingConstraint(geyserID, avoidNuggetSmall);
	    rmAddGroupingConstraint(geyserID, playerConstraint);
	    rmAddGroupingConstraint(geyserID, circleConstraint);
	    rmPlaceGroupingAtLoc(geyserID, 0, 0.5, 0.5, 2); 
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.99);
/*================================================================================================================*/
// ******************* 50% CHANCE OF BUFFALO CARCASSES - EITHER ONE OR TWO IF THEY'RE THERE: ******************** //
/*================================================================================================================*/
	    int areThereBuffalo=rmRandInt(1, 2);
	    int howManyBuffalo=rmRandInt(1, 2);
/*----------------------------------------------------------------------------------------------------------------*/		
	    if ( areThereBuffalo == 1 )
/*----------------------------------------------------------------------------------------------------------------*/		
	{
/*----------------------------------------------------------------------------------------------------------------*/	
		int bisonCarcass=rmCreateGrouping("Bison Carcass", "gp_carcass_bison");
		rmSetGroupingMinDistance(bisonCarcass, 0.0);
		rmSetGroupingMaxDistance(bisonCarcass, rmXFractionToMeters(0.5));
		rmAddGroupingConstraint(bisonCarcass, avoidNW);
		rmAddGroupingConstraint(bisonCarcass, avoidSE);
		rmAddGroupingConstraint(bisonCarcass, avoidImpassableLand);
		rmAddGroupingConstraint(bisonCarcass, playerConstraint);
		rmAddGroupingConstraint(bisonCarcass, avoidTradeRoute);
		rmAddGroupingConstraint(bisonCarcass, avoidSocket);
		rmAddGroupingConstraint(bisonCarcass, avoidStartingUnits);
		rmAddGroupingConstraint(bisonCarcass, avoidAll);
		rmAddGroupingConstraint(bisonCarcass, avoidNuggetSmall);
		rmPlaceGroupingAtLoc(bisonCarcass, 0, 0.5, 0.5, howManyBuffalo);
/*----------------------------------------------------------------------------------------------------------------*/		
	}		
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",1.00);
/*================================================================================================================*/
}
/*================================================================================================================*/
// ************************************** THIS IS THE END OF THE MAP: ******************************************* //
/*================================================================================================================*/  
	  
	  
	  
	  
	  
	  
	  
	  
	  
	  
	  
       
 	  
	  